<?php

$dir='yr/cache/';
$sc=scandir($dir);
foreach($sc as $file) {
	if(!is_dir($file) && ((filemtime($dir.'/'.$file) + 3600) < time())) {
		unlink($dir.$file);
	}
}
	
ini_set('display_errors', '1');

// Template for showing yr.no's xml-forecast by Henkka, http://www.nordicweather.net
// Vers. Oct 15 2009
//
// Requirements:
// - PHP 5
//*****************************************
// CONFIG START

// Units
$useC = 1;		// Use Celsius, else F
$useKMH = 1;		// Use Km/h
$useMPH = 0;		// Use Mph, if both KMH and MPH is zero is default m/s used
$useHPA = 1;		// Use hPa, else inHg
$useMM= 1;		// Use mm, else in

// Timesettings, normal PHP/date-tags used
$datestyle = "d/m/Y";		// Style of short date
$timestyle = "H:i";		// Style of time
$longdate = "d/m/Y H:i";	// Style of long time + date
$deftz = "Europe/Paris";
$pagename = "nom de votre page"; 

$geonameusr = "identifiant geonames.org"; // IMPORTANT! You need to signup at geonames.org (FREE), put username here
//$lang="FR";
// Cachesettings etc. settings
$qarefetchSeconds = 3600;	// How often it refresh the cache, 3600 recommended
$imgdir = "yr/images/";	// Icons-folder
$jsfolder = "yr/jquery/";
$cssfolder = "yr/css/";
$cachefolder = "yr/cache/";
$days = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
// Default place
$cod = "FR"; 
$cou = "France";
$cit = "Lagny-sur-Marne";
$lat = 48.875506;
$lon = 2.718806;

if($lang=="fi"){
define('YRDESC','<span style="font-weight:bold;color:red">UUTTA!</span> Voit selailla yli 3 miljoonan paikkakunnan ennusteita 240 maasta.<br/><b>Ohje:</b> Valitse ensin haluamasi maa, sen jälkeen kirjoita pari ensimmäistä kirjainta paikkakunnasta laatikkoon niin haku ehdottaa osumia.');
define('YRSEA','Valitse maa/paikkakunta');
define('TEMPERA','Lämpötila');
define('PRESSUR','Ilmanpaine');
define('PRECIPA','Sade/Kuurosade');
define('RAINA','Sade');
define('WINDA','Tuuli');
define('HUMIDA','Kosteus');
define('CLOUDS','Plivis.');
define('SMOG','Sumu');
define('FORECAST_FOR','Ennuste paikkakunnalle');
define('NEARBYCAMS','Lähistöllä olevia webkameroita');
define('LASTUPD','Edellinen päivitys');
define('NEXTUPD','Seuraava päivitys');
define('CAMSBY','Webkamerat toimittaa');
define('SAVEFAVO','Tallenna suosikkina');
define('TODAY','Tänään');
define('TOMORROW','Huomenna');
}else{
define('YRDESC','<span style=color:red><b>&nbsp;&nbsp;NOUVEAU !</b></span>&nbsp;&nbsp;Un&nbsp;choix&nbsp;de&nbsp;plus&nbsp;de&nbsp;3&nbsp;millions&nbsp;de&nbsp;pr&eacute;visions&nbsp;dans&nbsp;240&nbsp;pays.<br/><b>&nbsp;&nbsp;Comment&nbsp;?</b>&nbsp;Choisissez&nbsp;un&nbsp;pays&nbsp;dans&nbsp;la&nbsp;liste&nbsp;d&eacute;roulante,&nbsp;puis&nbsp;indiquez&nbsp;le&nbsp;code&nbsp;postal&nbsp;de&nbsp;la&nbsp;commune&nbsp;d&eacute;sir&eacute;e&nbsp;si&nbsp;vous&nbsp;le</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;connaissez&nbsp;ou&nbsp;tapez&nbsp;les&nbsp;premi&egrave;res&nbsp;lettres&nbsp;de&nbsp;la&nbsp;ville&nbsp;en&nbsp;commen&ccedil;ant&nbsp;par&nbsp;une&nbsp;majuscule&nbsp;puis&nbsp;choisissez&nbsp;parmi&nbsp;les&nbsp;suggestions.');
define('YRSEA','Choisir&nbsp;pays/ville');
define('TEMPERA','Temp&eacute;rature');
define('PRESSUR','Barom&egrave;tre');
define('PRECIPA','Pr&eacute;cipitations');
define('RAINA','Pr&eacute;cipitations');
define('WINDA','Vent');
define('HUMIDA','Humidit&eacute;');
define('CLOUDS','Nuages');
define('SMOG','Brouillard');
define('FORECAST_FOR','Pr&eacute;visions&nbsp;pour');
define('NEARBYCAMS','Webcams&nbsp;&agrave;&nbsp;proximit&eacute;');
define('LASTUPD','Derni&egrave;re&nbsp;mise&nbsp;&agrave;&nbsp;jour&nbsp;');
define('NEXTUPD','Prochaine&nbsp;mise&nbsp;&agrave;&nbsp;jour&nbsp;');
define('CAMSBY','Les&nbsp;webcam&nbsp;sont&nbsp;une&nbsp;courtoisie&nbsp;de');
define('SAVEFAVO','Enregistrer&nbsp;en&nbsp;tant&nbsp;que&nbsp;favori');
define('TODAY','Aujourd&rsquo;hui');
define('TOMORROW','Demain');
}


// CONFIG END
//**********************************************


$q = $_SERVER["QUERY_STRING"];
if ($q != "") {;
$q = explode("|",$q);
$lat = $q[1];
$lon = $q[2];
$tz = $q[3];
$cit = $q[4];
$cou = $q[5];
$cod = $q[6]; 

//$g = utf8_decode(urldecode($g));
//$gs = explode('/',$g);
//$g = str_replace("/","",strstr($g, '/'));

$mc = parse_url($_SERVER['HTTP_REFERER']);
$MH = $mc['host'];
}


if(isset($_COOKIE["yrfav-fr"]) && !is_numeric($lat)){
$q = explode("|",$_COOKIE["yrfav-fr"]);
$lat = $q[0];
$lon = $q[1];
$cit = $q[2];
$cou = $q[3];
$cod = $q[4];
$frcid = $lat.'|'.$lon.'|'.$cit.'|'.$cou.'|'.$cod;
}
elseif(!is_numeric($lat)&&isset($_SERVER["HTTP_GEOIP_LATITUDE"])){
$cod = $_SERVER["HTTP_GEOIP_CITY_COUNTRY_CODE"];
$cou = $_SERVER["HTTP_GEOIP_CITY_COUNTRY_NAME"];
$cit = $_SERVER["HTTP_GEOIP_CITY"];
$lat = $_SERVER["HTTP_GEOIP_LATITUDE"];
$lon = $_SERVER["HTTP_GEOIP_LONGITUDE"];
$frcid = $lat.'|'.$lon.'|'.$cit.'|'.$cou.'|'.$cod;
}
elseif(is_numeric($lat)){$frcid = $lat.'|'.$lon.'|'.$cit.'|'.$cou.'|'.$cod;}
else{$frcid = $lat.'|'.$lon.'|'.$cit.'|'.$cou.'|'.$cod;}

date_default_timezone_set($tz);
$qacacheName = $cachefolder.md5($lat.$lon).'.xml'; 
$URLS = "https://api.met.no/weatherapi/locationforecast/1.9/?lat=$lat&lon=$lon";	// URL to the ENGLISH page on yr.no where location is


// refresh cached copy of page if needed
// fetch/cache code by Tom at carterlake.org

if ($useC) { $uomtemp = "&deg;C"; } else { $uomtemp = "&deg;F"; }
if ($useKMH) { $uomwind = " km/h"; } else if ($useMPH) { $uomwind = " mph"; } else { $uomwind = " m/s";}
if ($useHPA) { $uombaro = " hPa"; } else { $uombaro = " inHg"; }
if ($useMM) { $uomrain = " mm"; } else { $uomrain = " in"; }

if (file_exists($qacacheName) and filemtime($qacacheName) + $qarefetchSeconds > time()) {
      $html = implode('', file($qacacheName));
      echo "<!-- using cached file $qacacheName-->\n";
    } else {
      $html = file_get_contents($URLS);
      $fp = file_put_contents($qacacheName, $html); 
      chmod($qacacheName, 0666);
      echo "<!-- using fresh file -->\n";
	 }

$xml=xml2ary($html);
$xml = $xml['weatherdata']['_c']; 
$forecasts = $xml['product']['_c'][time];

//print_r($xml);
if(isset($xml['meta']['_c']['model'][0]['_a'])){
$meta = $xml['meta']['_c']['model'][0]['_a'];
}else{
$meta = $xml['meta']['_c']['model']['_a'];
}
$lupd = $meta['runended'];
$lupd = date('d.m.Y H:i', parse_time($lupd));
$nupd = $meta['nextrun'];
$nupd = date('d.m.Y H:i', parse_time($nupd));


//echo "$offset $sunr $suns <br/>";

$howmany = count($forecasts);

echo "<!-- $howmany forecasts available -->\n";
//echo "$city $country $alt $lupd $nupd <br/><br/>";

$a = 0;
$last = 0;
$offset = date('Z');
$e = 0;
$prea = 0;
$nordic = false;
for ($i = 0; $i < $howmany; $i++) {


if(isset($forecasts[$i]['_c']['location']['_c']['temperature']['_a']['value'])){
if ($useKMH) {
$forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['mps'] = MStoKMH($forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['mps']);
$forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['name'] = "km/h";
}else if ($useMPH) {
$forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['mps'] = MStoMPH($forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['mps']); 
$forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['name'] = "mph";
}
$now = $i;
$diff = $now - $last;
$validfr = $forecasts[$i]['_a'][from];
$jstime = ((strtotime($validfr)+$offset)*1000);

$everysec = false;
if(($diff == 5||$a == 0) && isset($forecasts[$i+3]['_c']['location']['_c']['precipitation']['_a']['value'])){
$pr = 2;
$nordic = true;
$rbar = "3200000";
$prec = $forecasts[$i+1]['_c']['location']['_c']['precipitation']['_a']['value'];
$mprec = $forecasts[$i+1]['_c']['location']['_c']['precipitation']['_a']['value'];
$temps.='['.$jstime.',"'.$forecasts[$i]['_c']['location']['_c']['temperature']['_a']['value'].'"],';
$baros.='['.$jstime.',"'.$forecasts[$i]['_c']['location']['_c']['pressure']['_a']['value'].'"],';
$winds.='['.$jstime.','.$forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['mps'].'],';
if($mprec > 0){
$rains.='['.$jstime.','.$prec.'],';
$mrains.='['.$jstime.','.$mprec.'],';
$precs[] = $mprec;
}
if($e%2!=1){
$everysec = true;
}
$e++;
} elseif(($diff == 3||$a == 0) && isset($forecasts[$i+2]['_c']['location']['_c']['precipitation']['_a']['value'])){
$pr = 1;
if($nordic == false){$rbar = "8500000";
$prec = $forecasts[$i+$pr]['_c']['location']['_c']['precipitation']['_a']['value'];
$mprec = $forecasts[$i+$pr]['_c']['location']['_c']['precipitation']['_a']['value'];
$temps.='['.$jstime.',"'.$forecasts[$i]['_c']['location']['_c']['temperature']['_a']['value'].'"],';
$baros.='['.$jstime.',"'.$forecasts[$i]['_c']['location']['_c']['pressure']['_a']['value'].'"],';
$winds.='['.$jstime.','.$forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['mps'].'],';
if($prec > 0){
$rains.='['.$jstime.','.$prec.'],';
$mrains.='['.$jstime.','.$mprec.'],';
$precs[] = $mprec;
}
}
}else{
$pr = 1;
}

if($everysec == false){
$yrfr[$a]['dir'] = $forecasts[$i]['_c']['location']['_c']['windDirection']['_a']['deg'];
$yrfr[$a]['dirname'] = $forecasts[$i]['_c']['location']['_c']['windDirection']['_a']['name'];
$yrfr[$a]['spd'] = $forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['mps'];
$yrfr[$a]['spdname'] = $forecasts[$i]['_c']['location']['_c']['windSpeed']['_a']['name'];
$yrfr[$a]['temp'] = $forecasts[$i]['_c']['location']['_c']['temperature']['_a']['value'];
$yrfr[$a]['baro'] = $forecasts[$i]['_c']['location']['_c']['pressure']['_a']['value'];
$yrfr[$a]['hum'] = $forecasts[$i]['_c']['location']['_c']['humidity']['_a']['value'];
$yrfr[$a]['cloud'] = $forecasts[$i]['_c']['location']['_c']['cloudiness']['_a']['percent'];
$yrfr[$a]['fog'] = $forecasts[$i]['_c']['location']['_c']['fog']['_a']['percent'];
$yrfr[$a]['i'] = $i;
$icon = $forecasts[$i+$pr]['_c']['location']['_c']['symbol']['_a']['number'];
$yrfr[$a]['precip'] = $forecasts[$i+$pr]['_c']['location']['_c']['precipitation']['_a']['value'];
$yrfr[$a]['valid'] = strtotime($validfr);
$yrfr[$a]['validr'] = $validfr;
$validto = $forecasts[$i]['_a'][to];
$yrfr[$a]['validto'] = strtotime($validto);
$yrfr[$a]['validtor'] = $validto;
$fpday = checkday(strtotime($validfr));
if($fpday <> ''){$daychanges[] = (strtotime($validfr)+$offset)*1000;}
$sunstuff = '';
$sunstuff = yrsunstuff($lat,$lon,$icon,$yrfr[$a]['valid'],($offset/3600));
list($dayornight,$sunri,$sunse,$sunr,$suns,$icon) = $sunstuff;
$yrfr[$a]['icon'] = $icon;
$yrfr[$a]['sunri'] = $sunri;
$yrfr[$a]['sunse'] = $sunse;
$yrfr[$a]['debug'] = '<br/>|'.$lat.'|'.$lon.'|'.$dayornight.'|'.$icon.'|'.date('dmY H:i',$yrfr[$a]['valid']).'|';
$a++;
}
$last= $i;
} // EOF NEW
} // EOF LOOP

if(count($precs)>0){$precmax = max($precs);}else{$precmax = $precs;}
if($precmax < 10) {$precmax = 10;}
else{$precmax = round($precmax*1.1);}

for($i=1;$i<count($daychanges);$i++) {
if($i == count($daychanges)-1) {
$ddays.= '{xaxis: { from: '.$daychanges[$i].', to: '.((strtotime($validto)+$offset)*1000).' }, color: "rgba(255, 255, 255, 0.2)" }';
} else {
$ddays.= '{xaxis: { from: '.$daychanges[$i].', to: '.$daychanges[$i+1].' }, color: "rgba(255, 255, 255, 0.2)" },';
}
$i++;
}

$howmany = count($yrfr);
echo "<!-- $howmany forecasts available -->\n";
$yrhead = '
<link rel="stylesheet" type="text/css" href="'.$cssfolder.'style.css" media="all" />
<script src="'.$jsfolder.'jquery.1.6.4.min.js"></script>
<script src="'.$jsfolder.'jquery.ui.1.9.min.js?2.01"></script>
<script src="'.$jsfolder.'jquery.flot.js"></script>
<script src="'.$jsfolder.'jquery.jcarousel.min.js"></script>
<script>
<!--
$(document).ready(function(){
$("#frcfav").click(function() {
$.cookie("yrfav-fr", "'.$frcid.'", {expires: 365});
});
$("#country option[value='.$cod.']").attr("selected", "selected");
$(".uibutton").button();

$(function() {
$("#city").autocomplete({
   source: function( request, response ) {
     $.ajax({
      url: "http://ws.geonames.org/searchJSON",
      dataType: "jsonp",
      data: {
        featureClass: "P",
        style: "full",
        maxRows: 20,
        name_startsWith: request.term,
        country: $("#country :selected").val(),
        username: "'.$geonameusr.'"
      },
      success: function( data ) {
        response( $.map( data.geonames, function( item ) {
          return {
          label: item.name + (item.adminName1 ? ", " + item.adminName1 : ""),
          value: item.name,
          str: item.lat+"|"+item.lng+"|"+item.timezone.timeZoneId+"|"+encodeURIComponent(item.name)+"|"+encodeURIComponent(item.countryName)+"|"+encodeURIComponent(item.countryCode)
          }
        }));
      }
     });
	},
  minLength: 2,
  select: function( event, ui ) {
      window.location = "'.$pagename.'?'.$lang.'|"+ui.item.str;
			},
      open: function() {
				$( this ).removeClass( "ui-corner-all" ).addClass( "ui-corner-top" );
			},
      close: function() {
				$( this ).removeClass( "ui-corner-top" ).addClass( "ui-corner-all" );
			}

});
		
});

';
if($howmany>0){
$yrhead.= '
var temps = ['.substr($temps,0,-1).'];
var winds = ['.substr($winds,0,-1).'];
var rains = ['.substr($rains,0,-1).'];
var mrains = ['.substr($mrains,0,-1).'];
var baros = ['.substr($baros,0,-1).'];

var previousPoint = null;
$("#TOTCHART").bind("plothover", owntool);
$.plot($("#TOTCHART"),
        [{data:baros, lines: { show: true, fill: false, lineWidth: 2 },legend: {show: true}, 
        color: "#9ACD32",shadowSize: 0,yaxis:3,label:"'.PRESSUR.'"},
        {data:temps, lines: { show: true, fill: false, lineWidth: 2 },legend: {show: true}, 
        color: "#FF6D6D",threshold: { below: 0, color: "#87CEFA" },shadowSize: 0,label:"'.TEMPERA.'"},
   /*     {data:mrains, lines: { show: false,fill: true}, points:{ show: false },legend: {show: true},  
        bars: { show: true, fill: true, align: "right",barWidth: '.$rbar.',lineWidth:0 },
        color: "#4572A7",yaxis:2,label:"'.RAINA.'",
        color: "#4572A7",yaxis:2}, */
        {data:rains, lines: { show: false,fill: true}, points:{ show: false },legend: {show: true}, 
        bars: { show: true, fill: true, align: "right",barWidth: '.$rbar.',lineWidth:0 },
        color :"#4572A7",yaxis:2,label:"'.PRECIPA.'",
        color: "#4572A7",yaxis:2}
        ],
        {yaxes: [{minTickSize:1,tickDecimals:0,autoscaleMargin: 0.15},{min:0,max:'.$precmax.',alignTicksWithAxis: 1},
        {position: "right",min:960,max:1040,alignTicksWithAxis: 1,tickLength: 0}], 
        xaxes: [{ mode: "time",timeformat: "%H:%M",  tickSize: [6, "hour"] }
        ],
        grid: {tickColor: "#ddd", color:"#424242",  borderWidth: 1, borderColor: "#88BCCE",
        backgroundColor: { colors: ["#ddd", "#f2f2f2"] },hoverable: true, autoHighlight: true,
        markings: ['.$ddays.']},
        legend:{container: "#legenddiv", noColumns: 4}
        });

// FLOT TOOLS
function owntool(event, pos, item) {
        $("#x").text(pos.x.toFixed(2));
        $("#y").text(pos.y.toFixed(2));
        if (item) {
            var unit = "";           
            if (previousPoint != item.datapoint) {
                previousPoint = item.datapoint;        
                $("#tooltip").remove();
                var x = item.datapoint[0].toFixed(3);
                var y = item.datapoint[1].toFixed(1);
                var hy = new Date(x*1);
                var ho = hy.getUTCHours();
                var mi = hy.getUTCMinutes();
                if(mi<10){mi = "0"+mi;}
                if(item.series.label == "Temp&eacute;rature") { var unit = "&nbsp;&deg;C"; }
                if(item.series.label == null) { item.series.label = "Temp&eacute;rature";var unit = "&nbsp;&deg;C"; }
                if(item.series.label == "Point de ros&eacute;e") { var unit = "&nbsp;&deg;C"; }
                if(item.series.label == "Pr&eacute;cipitations") { var unit = "&nbsp;mm"; }
                if(item.series.label == "Pr&eacute;cipitations&nbsp;maxi") { var unit = "&nbsp;mm"; }
                if(item.series.label == "Rayonnement&nbsp;solaire") { var unit = "&nbsp;w/m&sup2;"; y = item.datapoint[1].toFixed(0);}
                if(item.series.label == "Possibilit&eacute;&nbsp;d&rsquo;orage") { var unit = "%"; y = item.datapoint[1].toFixed(0);}
                if(item.series.label == "Hauteur&nbsp;de&nbsp;neige") { var unit = "&nbsp;cm"; y = item.datapoint[1].toFixed(0);}
                if(item.series.label == "Rafale") { var unit = "&nbsp;m/s"; y = item.datapoint[1].toFixed(0);}
                if(item.series.label == "Pression") { var unit = "&nbsp;hPa"; y = item.datapoint[1].toFixed(1);}                
                showTooltip(item.pageX, item.pageY,
                "<b>"+item.series.label+"</b><br/>"+ ho + ":"+mi+"<br/><b>"+y+unit+"</b>");
            }
        }else{
            $("#tooltip").remove();
            previousPoint = null;            
            }
}

function showTooltip(x, y, contents) {
        $("<div id=\'tooltip\'>" + contents + "</div>").css({position: "absolute",display: "none",
        top: y + 12,left: x + 12,opacity: 0.90}).appendTo("body").fadeIn(200);
}
';
}
$yrhead.= '        
});
//-->
</script>
';
$table.= '<p>'.YRDESC.'<br/>
<table style="width:100%"border:0; margin: 0 auto;"><tr style="valign:middle;">
<!--<td class="yrrow" style="text-align: left; padding: 10px 15px 10px 15px;">
<div style="float:left">
 <a class="uibutton" id="frcfav">'.SAVEFAVO.'</a>  
</div> 
</td>-->
<td class="yrrow" style="text-align: right; padding: 10px 15px 10px 15px;">      
<div class="demo" style="float:center;position:relative;right:10px;">
<div class="ui-widget">
<fieldset>
<label for="country">' . YRSEA . ' </label>
<select id="country" name="country" style="width: 150px;">
<option DISABLED> ------- Choisir un pays -------</option>
<option value="FR">France</option>
<option value="GP">France - Guadeloupe</option>
<option value="GF">France - Guyane</option>
<option value="MQ">France - Martinique</option>
<option value="YT">France - Mayotte</option>
<option value="NC">France - Nouvelle Cal&eacute;donie</option>
<option value="PF">France - Polyn&eacute;sie</option>
<option value="RE">France - R&eacute;union</option>
<option value="PM">France - Saint Pierre et Miquelon</option>
<option value="TF">France - Terres australes</option>
<option value="WF">France - Wallis And Futuna</option>
<option value="BE">Belgique</option>
<option value="LU">Luxembourg</option>
<option value="CH">Suisse</option>
<option DISABLED> ------------------------------ </option>
<option value="AF">Afghanistan</option>
<option value="ZA">Afrique du sud</option>
<option value="AX">Aland, Îles</option>
<option value="AL">Albanie</option>
<option value="DZ">Algérie</option>
<option value="DE">Allemagne</option>
<option value="AD">Andorre</option>
<option value="AO">Angola</option>
<option value="AI">Anguilla</option>
<option value="AQ">Antarctique</option>
<option value="AG">Antigua et Barbuda</option>
<option value="AN">Antilles Néerlandaises</option>
<option value="SA">Arabie Saoudite</option>
<option value="AR">Argentine</option>
<option value="AM">Arménie</option>
<option value="AW">Aruba</option>
<option value="AU">Australie</option>
<option value="AT">Autriche</option>
<option value="AZ">Azerbaïdjan</option>
<option value="BS">Bahamas</option>
<option value="BH">Bahreïn</option>
<option value="BD">Bangladesh</option>
<option value="BB">Barbade</option>
<option value="BE">Belgique</option>
<option value="BZ">Belize</option>
<option value="BJ">Bénin</option>
<option value="BM">Bermudes</option>
<option value="BT">Bhoutan</option>
<option value="BY">Biélorussie</option>
<option value="BO">Bolivie</option>
<option value="BA">Bosnie Herzégovine</option>
<option value="BW">Botswana</option>
<option value="BV">Bouvet, Île</option>
<option value="BR">Brésil</option>
<option value="BN">Brunéi Darussalam</option>
<option value="BG">Bulgarie</option>
<option value="BF">Burkina Faso</option>
<option value="BI">Burundi</option>
<option value="KY">Caïmans, Îles</option>
<option value="KH">Cambodge</option>
<option value="CM">Cameroun</option>
<option value="CA">Canada</option>
<option value="CV">Cap Vert</option>
<option value="CF">Centrafricaine, République</option>
<option value="CL">Chili</option>
<option value="CN">Chine</option>
<option value="CX">Christmas, Île</option>
<option value="CY">Chypre</option>
<option value="CC">Cocos, Îles</option>
<option value="CO">Colombie</option>
<option value="KM">Comores</option>
<option value="CG">Congo</option>
<option value="CD">Congo, République démocratique du</option>
<option value="CK">Cook, Îles</option>
<option value="KR">Corée, République de</option>
<option value="KP">Corée, République populaire démocratique de</option>
<option value="CR">Costa Rica</option>
<option value="CI">Côte d&rsquo;Ivoire</option>
<option value="HR">Croatie</option>
<option value="CU">Cuba</option>
<option value="DK">Danemark</option>
<option value="DJ">Djibouti</option>
<option value="DO">Dominicaine, République</option>
<option value="DM">Dominique</option>
<option value="EG">Egypte</option>
<option value="AE">Emirats Arabes Unis</option>
<option value="EC">Equateur</option>
<option value="ER">Erythrée</option>
<option value="ES">Espagne</option>
<option value="EE">Estonie</option>
<option value="US">Etats-Unis</option>
<option value="ET">Ethiopie</option>
<option value="FK">Falklands, Îles (Malouines)</option>
<option value="FO">Féroé, Îles</option>
<option value="FJ">Fidji</option>
<option value="FI">Finlande</option>
<option value="FR">France</option>
<option value="GA">Gabon</option>
<option value="GM">Gambie</option>
<option value="GE">Géorgie</option>
<option value="GS">Géorgie du Sud-et-les Îles Sandwich du Sud</option>
<option value="GH">Ghana</option>
<option value="GI">Gibraltar</option>
<option value="GR">Grèce</option>
<option value="GD">Grenade</option>
<option value="GL">Groenland</option>
<option value="GP">Guadeloupe</option>
<option value="GU">Guam</option>
<option value="GT">Guatemala</option>
<option value="GN">Guinée</option>
<option value="GQ">Guinée équatoriale</option>
<option value="GW">Guinée-Bissau</option>
<option value="GY">Guyana</option>
<option value="GF">Guyane française</option>
<option value="HT">Haïti</option>
<option value="HM">Heard-et-MacDonald, Îles</option>
<option value="HN">Honduras</option>
<option value="HK">Hong-Kong</option>
<option value="HU">Hongrie</option>
<option value="UM">Îles mineures éloignées des Etats-Unis</option>
<option value="VG">Îles Vierges britanniques</option>
<option value="VI">Îles Vierges des Etats-Unis</option>
<option value="IN">Inde</option>
<option value="ID">Indonésie</option>
<option value="IQ">Irak</option>
<option value="IR">Iran</option>
<option value="IE">Irlande</option>
<option value="IS">Islande</option>
<option value="IL">Israël</option>
<option value="IT">Italie</option>
<option value="JM">Jamaïque</option>
<option value="JP">Japon</option>
<option value="JO">Jordanie</option>
<option value="KZ">Kazakhstan</option>
<option value="KE">Kenya</option>
<option value="KG">Kirghizistan</option>
<option value="KI">Kiribati</option>
<option value="KW">Koweït</option>
<option value="LA">Laos</option>
<option value="LS">Lesotho</option>
<option value="LV">Lettonie</option>
<option value="LB">Liban</option>
<option value="LR">Liberia</option>
<option value="LY">Libyenne, Jamahiriya arabe</option>
<option value="LI">Liechtenstein</option>
<option value="LT">Lituanie</option>
<option value="LU">Luxembourg</option>
<option value="MO">Macao</option>
<option value="MK">Macédoine</option>
<option value="MG">Madagascar</option>
<option value="MY">Malaisie</option>
<option value="MW">Malawi</option>
<option value="MV">Maldives</option>
<option value="ML">Mali</option>
<option value="MT">Malte</option>
<option value="MP">Mariannes du Nord, Îles</option>
<option value="MA">Maroc</option>
<option value="MH">Marshall, Îles</option>
<option value="MQ">Martinique</option>
<option value="MU">Maurice</option>
<option value="MR">Mauritanie</option>
<option value="YT">Mayotte</option>
<option value="MX">Mexique</option>
<option value="FM">Micronésie, Etats fédérés de</option>
<option value="MD">Moldavie</option>
<option value="MC">Monaco</option>
<option value="MN">Mongolie</option>
<option value="ME">Monténégro</option>
<option value="MS">Montserrat</option>
<option value="MZ">Mozambique</option>
<option value="MM">Myanmar</option>
<option value="NA">Namibie</option>
<option value="NR">Nauru</option>
<option value="NP">Népal</option>
<option value="NI">Nicaragua</option>
<option value="NE">Niger</option>
<option value="NG">Nigéria</option>
<option value="NU">Niue</option>
<option value="NF">Norfolk, Île</option>
<option value="NO">Norvège</option>
<option value="NC">Nouvelle-Calédonie</option>
<option value="NZ">Nouvelle-Zélande</option>
<option value="IO">Océan Indien, Territoire britannique de l&rsquo;</option>
<option value="OM">Oman</option>
<option value="UG">Ouganda</option>
<option value="UZ">Ouzbkistan</option>
<option value="PK">Pakistan</option>
<option value="PW">Palaos</option>
<option value="PA">Panama</option>
<option value="PG">Papouasie-Nouvelle-Guinée</option>
<option value="PY">Paraguay</option>
<option value="NL">Pays-Bas</option>
<option value="PE">Pérou</option>
<option value="PH">Philippines</option>
<option value="PN">Pitcairn, Îles</option>
<option value="PL">Pologne</option>
<option value="PF">Polynésie française</option>
<option value="PR">Porto Rico</option>
<option value="PT">Portugal</option>
<option value="QA">Qatar</option>
<option value="CZ">République Tchèque</option>
<option value="RE">Réunion</option>
<option value="RO">Roumanie</option>
<option value="GB">Royaume-Uni</option>
<option value="RU">Russie</option>
<option value="RW">Rwanda</option>
<option value="EH">Sahara occidental</option>
<option value="KN">Saint-Kitts-et-Nevis</option>
<option value="SM">Saint-Marin</option>
<option value="PM">Saint-Pierre-et-Miquelon</option>
<option value="VC">Saint-Vincent-et-les-Grenadines</option>
<option value="SH">Sainte-Hélène, Ascension et Tristan da Cunha</option>
<option value="LC">Sainte-Lucie</option>
<option value="SB">Salomon, Îles</option>
<option value="SV">Salvador, El</option>
<option value="WS">Samoa</option>
<option value="AS">Samoa américaines</option>
<option value="ST">Sao Tomé-et-Principe</option>
<option value="SN">Sénégal</option>
<option value="RS">Serbie</option>
<option value="SC">Seychelles</option>
<option value="SL">Sierra Leone</option>
<option value="SG">Singapour</option>
<option value="SK">Slovaquie</option>
<option value="SI">Slovénie</option>
<option value="SO">Somalie</option>
<option value="SD">Soudan</option>
<option value="LK">Sri Lanka</option>
<option value="SE">Suède</option>
<option value="CH">Suisse</option>
<option value="SR">Suriname</option>
<option value="SJ">Svalbard et Île Jan Mayen</option>
<option value="SZ">Swaziland</option>
<option value="SY">Syrie</option>
<option value="TJ">Tadjikistan</option>
<option value="TW">Taïwan</option>
<option value="TZ">Tanzanie</option>
<option value="TD">Tchad</option>
<option value="TF">Terres australes françaises</option>
<option value="PS">Territoires palestiniens</option>
<option value="TH">Thaïlande</option>
<option value="TL">Timor-Leste</option>
<option value="TG">Togo</option>
<option value="TK">Tokelau</option>
<option value="TO">Tonga</option>
<option value="TT">Trinité-et-Tobago</option>
<option value="TN">Tunisie</option>
<option value="TM">Turkmenistan</option>
<option value="TC">Turks-et-Cacos, Îles</option>
<option value="TR">Turquie</option>
<option value="TV">Tuvalu</option>
<option value="UA">Ukraine</option>
<option value="UY">Uruguay</option>
<option value="VU">Vanuatu</option>
<option value="VA">Vatican</option>
<option value="VE">Venezuela</option>
<option value="VN">Vietnam</option>
<option value="WF">Wallis et Futuna</option>
<option value="YE">Yémen</option>
<option value="ZM">Zambie</option>
<option value="ZW">Zimbabwe</option>
</select>
<input id="city" style="width:320px;"/>   
</fieldset>
</div>
</div>

</div>
</div>


</td>


</tr><tr>
<td colspan=2">
<div class="nordui-table-header-b" style="height:24px;text-align:left">
<!-- <span style="float:right"><img alt="" src="'.$imgdir.'yrno.png" style="height:15px;width:58px;position:relative;top:5px;left:-10px;"/></span> -->
<h4 style="line-height:24px;text-shadow:none;">' . FORECAST_FOR . ' ' . mb_convert_encoding(urldecode($cit),'iso-8859-1','utf-8'). ', '.utf8_decode(urldecode($cou)).'</h4>
</div>
</td>
</tr>
</table>
<table style="width:100%">
<tr>
<td class="yrrow" style="text-align: left; padding: 10px 15px 10px 15px; width: 50%;">
<b>' . LASTUPD . ':</b> ' . $lupd . '<br/>
<b>' . NEXTUPD . ':</b> ' . $nupd . '
</td>
<td class="yrrow" style="text-align: right; padding: 10px 15px 10px 15px; width: 50%;">
Latitude: '.fixlat(round($forecasts[$i]['_c']['location']['_a']['latitude'],2)).'<br/>
Longitude: '.fixlon(round($forecasts[$i]['_c']['location']['_a']['longitude'],2)).'<br/>
Altitude: '.$forecasts[$i]['_c']['location']['_a']['altitude'].' m
</td></tr></table>
<br/>
<div class="flotwrap shadow5">
<div style="float:right;font-size:10px;padding:0 5px 8px 0;color:#424242;">hPa</div>
<div style="position:relative; left: 1px;font-size:10px;padding:0 0 8px 5px;color:#424242;">mm
<span style="position:relative; left: 10px;font-size:10px;padding:0 0 8px 5px;color:#424242;">&deg;C</span></div>
<div style="height:250px;;" id="TOTCHART"></div>
<div style="height:30px;width:250px;margin-top:25px;" id="legenddiv"></div>
</div>

<div style="padding-top:15px;margin:0 auto;width:728px;">
'.$banner.'
</div>

<table class="nordui-table shadow5" style="width:100%">
<tr class="nordui-table-header">
<td class="nordui-table-td" class="nordui-table-td" style="width:90px"><b>&nbsp;</b></td>
<td class="nordui-table-td" style="width:90px"><b>&nbsp;</b></td>
<td class="nordui-table-td" style="width:90px"><b>'.TEMPERA.'</b></td>
<td class="nordui-table-td" style="width:100px"><b>'.RAINA.'</b></td>
<td class="nordui-table-td" style="width:100px"><b>'.PRESSUR.'</b></td>
<td class="nordui-table-td" style="width:120px"><b>'.WINDA.'</b></td>
<td class="nordui-table-td" style="width:80px"><b>'.HUMIDA.'</b></td>
<td class="nordui-table-td" style="width:80px"><b>'.CLOUDS.'</b></td>
<td class="nordui-table-td" style="width:80px"><b>'.SMOG.'</b></td>
</tr>

';


for ($i = 0; $i < $howmany; $i++) {
//$wind = windspeed($spdname) . ' ' . FROM . ' ' . winddirs(strtolower($dirname)) . '' . WEXT;

if($i % 2 == 1) {
$bgcolor = "nordui-table-a";
} else {
$bgcolor = "nordui-table-b";
}
$fpday = checkday($yrfr[$i][valid]);
if($fpday<>''){
$table.='<tr class="nordui-table-subheader"><td class="nordui-table-td" style="width:100%;padding-left:10px;" colspan="9">
<span style="float:right;position:relative;right:11px;font-size:10px;">'.fixsun($yrfr[$i][sunri],$yrfr[$i]['sunse']).'</span>
<span style="position:relative;top:2px"><b>'.$fpday.'</b></span></td></tr>';
}else{
$topborder = "";
}

$table.='<tr class="'.$bgcolor.'">
<td class="nordui-table-td" style="width:90px;text-align: center;">'.mb_convert_encoding(date('H:i',$yrfr[$i]['valid']),"ISO-8859-1","UTF-8").'</td>
<td class="nordui-table-td" style="width:90px;text-align: center;"><span style="display:inline-block;" class="dotvoidsprites n'.str_replace(".","_",$yrfr[$i][icon]).'_png" ></span></td>
<td class="nordui-table-td" style="width:90px;text-align: center;"><img src="'.$imgdir.'bignums/'.fixtemp(round($yrfr[$i]['temp'])).'.png" alt=""/></td>
<td class="nordui-table-td" style="width:100px;text-align: center;color:#1874CD;">'.fixprecip($yrfr[$i]['precip']).'</td>
<td class="nordui-table-td" style="width:100px;text-align: center;">' . $yrfr[$i][baro]. $uombaro . '</td>
<td class="nordui-table-td" style="width:120px;text-align: center;"><span style="display:inline-block;" class="windsprites '.strtoupper($yrfr[$i][dirname]).'_png"></span> '.$yrfr[$i]['spd'].' '.$uomwind.'</td>
<td class="nordui-table-td" style="width:80px;text-align: center;">'.checkhum(round($yrfr[$i]['hum'])).'</td>
<td class="nordui-table-td" style="width:80px;text-align: center;">'.checkcloud(round($yrfr[$i]['cloud']),$yrfr[$i]['hum']).'</td>
<td class="nordui-table-td" style="width:80px;text-align: center;">'.checkhum(round($yrfr[$i]['fog'])).'</td>
</tr>';
}

$table .= '<tr><td class="nordui-table-td" colspan="10"><div style="padding-top: 2px; border-bottom: 1px solid #ccc;">&nbsp;</div><div style="text-align: left;margin:0 auto;width:99%;">Pr&eacute;visions&nbsp;m&eacute;t&eacute;o&nbsp;de&nbsp;yr.no,&nbsp;d&eacute;livr&eacute;es&nbsp;par&nbsp;l&rsquo;<a href="http://www.met.no/" target="_new" style="color:blue;">Institut M&eacute;t&eacute;orologique&nbsp;Norv&eacute;gien<span style="display:inline-block;" class="miscsprites extlink_gif"></span></a>&nbsp;et&nbsp;la&nbsp;NRK&nbsp;<br/>Script&nbsp;&eacute;crit&nbsp;par Henkka du site&nbsp;<a href="http://www.nordicweather.net" target="_new" style="color:blue;">nordicweather.net <span style="display:inline-block;" class="miscsprites extlink_gif"></span></a>&nbsp;&nbsp;Script du m&eacute;t&eacute;ogramme modifi&eacute; par Helmain du site&nbsp<a href="http://toutletempslaniaque.net" target="_new" style="color:blue;">toutletempslaniaque.net <span style="display:inline-block;" class="miscsprites extlink_gif"></span></a></div></td></tr></table>
'.$cam.'';
$yrtable = $table;
date_default_timezone_set($deftz);

// ----------------------------functions ----------------------------------- 

function checkhum($val){
if($val == 0){return;}
else{return $val.'%';}
}

function checkcloud($val,$cval){
if($cval == 0){return;}
else{return $val.'%';}
}

function fixlat($raw){
if($raw < 0) { return str_replace("-","",$raw).'&deg; S';}
else{return $raw.'&deg; N';}
}
function fixlon($raw){
if($raw < 0) { return str_replace("-","",$raw).'&deg; W';}
else{return $raw.'&deg; E';}
}

function fixsun($sunri,$sunse){
$m = date('n');
if($sunri == "--" && ($m < 4 || $m > 9)){
return "Kaamosaika";
}elseif($sunri == "--" && $m > 4 && $m < 9){
return "Keskiyön aurinko";
}else{
return '<span style="display:inline-block;position:relative;top:4px;" class="miscsprites sun_up"></span>&nbsp;'.$sunri.'&nbsp;&nbsp;&nbsp;
<span style="display:inline-block;position:relative;top:4px;" class="miscsprites sun_down"></span>&nbsp;'.$sunse;
}
}

function checkday($val){
global $lastday,$days;
$curr = date('z', time());
$va  = date('z', $val);
$vv  = date('w', $val);
$mois = array('','janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre');
$day = '';
if($va == $lastday){return $day;}
if($curr == $va) {
$day = TODAY;
} else if(($va-$curr) == 1 || ((date("L",$val) == 0 && $va-$curr == 364)||(date("L",$val) == 1 && $va-$curr == 365))) {
$day = TOMORROW;
} else {
$day = $days[$vv].'&nbsp;'.date('j',$val).'&nbsp;'.$mois[date('n',$val)].'&nbsp;'.date('Y',$val);
}
$lastday = $va;
return $day;
}

function fixtemp($val) {
$val = str_replace("-0","0",$val);
if($val<0){return str_replace("-","n",$val);}
else{return $val;}
}

function fixprecip($val){
if($val > 0) {
return "$val mm";
} else {
return "&nbsp;";
}
}

function MStoMPH ($ms, $prec=0) {
	$prec = (integer)$prec;
	$mph = (float)(2.236936292 * $ms);
	return round($mph, $prec);
}

function mmToin ($mm) {
  $in = $mm * .0394;
  return sprintf("%01.2f",$in);
}

function MStoKMH ($ms, $prec=0) {
	$prec = (integer)$prec;
	$kmh = (float)(3.6 * $ms);
	return round($kmh, $prec);
}

function HPAtoIN ($baro) {
	//$prec = (integer)$prec;
	$ibaro = 0.0295333727 * $baro;
	return sprintf("%01.2f",$ibaro);
}

function CtoF ($cTemp, $prec=0) {
	$prec = (integer)$prec;
	$fTemp = (float)(1.8 * $cTemp) + 32;
	return round($fTemp, $prec);
}

function parse_daytime($raw) {
if($raw == 1) { $dttxt = NIGHT; }
if($raw == 2) { $dttxt = MORNING; }
if($raw == 3) { $dttxt = DAY; }
if($raw == 4) { $dttxt = EVENING; }
return $dttxt;
}

function wspeed($spd) {
$spd = round($spd);
if($spd == 0) { $spdtxt = CALM; }
if(($spd > 0) && ($spd < 1.4)) { $spdtxt = WWLIGHT; }
if(($spd > 1.4) && ($spd < 3.5)) { $spdtxt = WLIGHT; }
if(($spd >= 3.5) && ($spd < 5.5)) { $spdtxt = WBLIGHT; }
if(($spd >= 5.5) && ($spd < 8)) { $spdtxt = WMLIGHT; }
if(($spd >= 8) && ($spd < 13.9)) { $spdtxt = WMODERATE; }
if(($spd >= 13.9) && ($spd < 20.8)) { $spdtxt = WHARD; }
if($spd >= 20.8) { $spdtxt = WSTORM; }

return $spdtxt;
}

function parse_time($raw) {

$yr = substr($raw,0,4);
$mt = substr($raw,5,2);
$da = substr($raw,8,2);
$hr = substr($raw,11,2);
$mi = substr($raw,14,2);

$tm = mktime($hr,$mi,00,$mt,$da,$yr);
return $tm;
}

function parseToXML($htmlStr) 
{ 
$xmlStr=str_replace('<','&lt;',$htmlStr); 
$xmlStr=str_replace('>','&gt;',$xmlStr); 
$xmlStr=str_replace('"','&quot;',$xmlStr); 
$xmlStr=str_replace("'",'&#39;',$xmlStr); 
$xmlStr=str_replace("&",'&amp;',$xmlStr); 
return $xmlStr; 
} 

function parseTohtml($htmlStr) 
{ 
$xmlStr=str_replace('<','&lt;',$htmlStr); 
return $xmlStr; 
} 

function yrsunstuff($lat,$lon,$raw,$time,$offset){
$dl = date("I");
if ($dl == 1) {
$offset = "+2"; $toffset = 0;
} else {
$offset = "+1"; $toffset = 0;
}
$zenith=90+33/60;
$sunri = date_sunrise($time, SUNFUNCS_RET_STRING, $lat, $lon, $zenith, $offset);
$sunse = date_sunset($time, SUNFUNCS_RET_STRING, $lat, $lon, $zenith, $offset);
$sunrise_epoch = date_sunrise($time, SUNFUNCS_RET_TIMESTAMP, $lat, $lon, $zenith, $offset);
$sunset_epoch  = date_sunset($time, SUNFUNCS_RET_TIMESTAMP, $lat, $lon, $zenith, $offset);

if ($time >= $sunset_epoch or $time <= $sunrise_epoch) {
$dayornight = 'n';
} else {
$dayornight = '';
}
$micons = array('1', '2', '3', '5', '6', '7', '8');
if($dayornight == 'n' && in_array($raw,$micons)){
$raw = $raw.'n';
}

$sunr = strtotime($sunri);
$suns = strtotime($sunse);
$m = date('m');
if(($m > 4 && $m < 9) && ($sunri == '')) { $sunri = '--'; }
if(($m > 4 && $m < 9) && ($sunse == '')) { $sunse = '--'; }
if(($m > 9 && $m < 4) && ($sunse == '')) { $sunse = '--'; }
if(($m > 9 && $m < 4) && ($sunri == '')) { $sunri = '--'; }
if(($m > 4 && $m < 9) && ($sunri == '--')) { $raw = str_replace('n', '', $raw);$dayornight = ''; }
if(($m > 9 && $m < 4) && ($sunse == '--')) { $raw = str_replace('', 'n', $raw);$dayornight = 'n'; }

$ret = array($dayornight,$sunri,$sunse,$sunr,$suns,$raw);
return $ret;
}

// XML to Array
function xml2ary(&$string) {
    $parser = xml_parser_create();
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parse_into_struct($parser, $string, $vals, $index);
    xml_parser_free($parser);

    $mnary=array();
    $ary=&$mnary;
    foreach ($vals as $r) {
        $t=$r['tag'];
        if ($r['type']=='open') {
            if (isset($ary[$t])) {
                if (isset($ary[$t][0])) $ary[$t][]=array(); else $ary[$t]=array($ary[$t], array());
                $cv=&$ary[$t][count($ary[$t])-1];
            } else $cv=&$ary[$t];
            if (isset($r['attributes'])) {foreach ($r['attributes'] as $k=>$v) $cv['_a'][$k]=$v;}
            $cv['_c']=array();
            $cv['_c']['_p']=&$ary;
            $ary=&$cv['_c'];

        } elseif ($r['type']=='complete') {
            if (isset($ary[$t])) { // same as open
                if (isset($ary[$t][0])) $ary[$t][]=array(); else $ary[$t]=array($ary[$t], array());
                $cv=&$ary[$t][count($ary[$t])-1];
            } else $cv=&$ary[$t];
            if (isset($r['attributes'])) {foreach ($r['attributes'] as $k=>$v) $cv['_a'][$k]=$v;}
            $cv['_v']=(isset($r['value']) ? $r['value'] : '');

        } elseif ($r['type']=='close') {
            $ary=&$ary['_p'];
        }
    }    
    
    _del_p($mnary);
    return $mnary;
}

// _Internal: Remove recursion in result array
function _del_p(&$ary) {
    foreach ($ary as $k=>$v) {
        if ($k==='_p') unset($ary[$k]);
        elseif (is_array($ary[$k])) _del_p($ary[$k]);
    }
}

// Array to XML
function ary2xml($cary, $d=0, $forcetag='') {
    $res=array();
    foreach ($cary as $tag=>$r) {
        if (isset($r[0])) {
            $res[]=ary2xml($r, $d, $tag);
        } else {
            if ($forcetag) $tag=$forcetag;
            $sp=str_repeat("\t", $d);
            $res[]="$sp<$tag";
            if (isset($r['_a'])) {foreach ($r['_a'] as $at=>$av) $res[]=" $at=\"$av\"";}
            $res[]=">".((isset($r['_c'])) ? "\n" : '');
            if (isset($r['_c'])) $res[]=ary2xml($r['_c'], $d+1);
            elseif (isset($r['_v'])) $res[]=$r['_v'];
            $res[]=(isset($r['_c']) ? $sp : '')."</$tag>\n";
        }
        
    }
    return implode('', $res);
}

// Insert element into array
function ins2ary(&$ary, $element, $pos) {
    $ar1=array_slice($ary, 0, $pos); $ar1[]=$element;
    $ary=array_merge($ar1, array_slice($ary, $pos));
}

   
// ----------------------------------------------------------

function fixsynsno($val) {
if($val == "0"){$val = '';}
if($val == "0 km"){$val = '';}
return $val;
}
      
function charset($word) {
$word = str_replace('æ', '&aelig;', $word);
$word = str_replace('ø', '&oslash;', $word);
$word = str_replace('å', '&aring;', $word);
$word = str_replace('ä', '&auml;', $word);
$word = str_replace('ö', '&ouml;', $word);
$word = str_replace('+', '&Aring;', $word);
$word = str_replace('-', '&Auml;', $word);
$word = str_replace('Ö', '&Ouml;', $word);
$word = str_replace('Ø', '&Oslash;', $word);

return $word;
}

function aksort(&$array,$valrev=false,$keyrev=false) {
  if ($valrev) { arsort($array); } else { asort($array); }
    $vals = array_count_values($array);
    $i = 0;
    foreach ($vals AS $val=>$num) {
        $first = array_splice($array,0,$i);
        $tmp = array_splice($array,0,$num);
        if ($keyrev) { krsort($tmp); } else { ksort($tmp); }
        $array = array_merge($first,$tmp,$array);
        unset($tmp);
        $i = $num;
    }
}

function removeline($name) {
$clen = strlen($name);
if ($clen > 14) {
$name = strstr($name, ',');
$name = str_replace(',', '', $name);
}
return $name;
}

function tempcolor($temp) {
if($temp <= 0) {
$tcolor = "#1874CD";
} else {
$tcolor = "#CC1111";
}
return $tcolor;
}   
?>

